<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Src/NLME/FirstStage/FirstStage.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_413f4e031a85da0d68269c6fd2f76e1c.html">Src</a></li><li class="navelem"><a class="el" href="../../dir_8672bca13fc16af0e54d5ddc01090308.html">NLME</a></li><li class="navelem"><a class="el" href="../../dir_ad567f6568f7af71f68706673af51f33.html">FirstStage</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">FirstStage.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d7/d01/_first_stage_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="../../d7/d01/_first_stage_8m.html#a7db8a749658a67a5fefefd5909903f73">    1</a></span>&#160;<span class="keyword">function</span> <a class="code" href="../../d7/d01/_first_stage_8m.html#a7db8a749658a67a5fefefd5909903f73">FirstStage</a>(model_struct,data_table, fname)</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;%</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;%   Lines that MAY have to modified by the USER:</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;%         a) parallellization options</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;warning(<span class="stringliteral">&#39;off&#39;</span>,<span class="stringliteral">&#39;all&#39;</span>)</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;addpath(genpath(<span class="stringliteral">&#39;FirstStage_objs&#39;</span>))             % path to objective functions used</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;Model=model_struct;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;data=data_table;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;% Output directory</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;out_dir=Model.outdir;                         % path to store the results</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;% parpool starts with local profile, change <span class="stringliteral">&#39;local&#39;</span> to any other cluster profile</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;c = parcluster(Model.parProfile);</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;c.NumWorkers = Model.parWorkers;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;%parpool(c, c.NumWorkers);</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;% Load the data: data should contain columns Y, ID and TIME at the most.</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;ids = unique(data.TrackID);</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;%%%%%%%%%% Tweaking parameters: %%%%%%%%%%</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;% Initialise</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;beta_init =Model.indParams.inits;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;theta_init = Model.noiseParams.inits;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;n_kinetic_params=length(beta_init);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;% Parameters that can be tuned:</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;% tolerances <span class="keywordflow">for</span> optimizer convergence</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;x_tol=Model.optim.tols;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;f_tol=x_tol;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;x_tol_gls=x_tol;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;f_tol_gls=f_tol;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;% tolerances to the ODE SOLVER</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;int_opts=<span class="keyword">struct</span>();</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keywordflow">if</span> isempty(Model.simulation.options)</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    int_opts.abstol=1e-8;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    int_opts.rtol=1e-6;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    int_opts.k=[];</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;else</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    int_opts.abstol=Model.simulation.abstol;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    int_opts.rtol=Model.simulation.rtol;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    int_opts.k=Model.simulation.k;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;end</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;% Convergences</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;max_iter_GLS=Model.GLS.max_iters;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;min_iter_GLS=Model.GLS.min_iters;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;max_score=Model.GLS.max_score;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;% Objective function used to estimate the noise parameters</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;n_cells=length(ids);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;% Pre initialze the array to store the results of the individual fits.</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;x_ols = zeros(n_cells, n_kinetic_params);  % Store individual parameters</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;fval_ols = zeros(1, n_cells);              % Store the function values</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;exflg=zeros(1,n_cells);</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;% Finding initial estimates</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;if ~isfile([&#39;.&#39;,filesep,&#39;UserFns&#39;,filesep,&#39;<a class="code" href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a>.m&#39;])</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            disp(&#39;Using the default simulation file&#39;)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;end</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;t1 = tic;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;spmd, cpu0 = cputime(); end</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    n_observables=length(Model.noiseParams.type);</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;parfor i = 1: n_cells</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    int_opts=struct();</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    if isempty(Model.simulation.options)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        int_opts.abstol=Model.simulation.abstol;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        int_opts.rtol=Model.simulation.rtol;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        int_opts.k=[];</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        int_opts.t0=[];</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    else</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        int_opts.abstol=Model.simulation.abstol;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        int_opts.rtol=Model.simulation.rtol;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        int_opts.k=Model.simulation.k;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        int_opts.t0=Model.simulation.t0;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    end</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    t = unique(data.Time(data.TrackID == ids(i)));</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    switch n_observables</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        case 1</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            fun = @(para) <a class="code" href="../../db/d07/_o_l_s_8m.html#adb856b6f2c035e44401151c19a1b16e4">OLS</a>(t,para,data(data.TrackID == ids(i),:) ,int_opts);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        otherwise</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            % Get initial weights using splines</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            % h: weights we get from fitting a spline on the individual cells</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            if ~isfile([&#39;.&#39;,filesep,&#39;UserFns&#39;,filesep,&#39;getWeights.m&#39;])</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                if i==1</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            disp(&#39;Using the default weight calculation for <a class="code" href="../../de/da6/_w_o_l_s_8m.html#a13947ac7e36c1a321510c2c370e26450">WOLS</a> based initial estimates&#39;)</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;                end</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            end</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            data_cell=data(data.TrackID == ids(i),:);</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            h=getWeights(data_cell);</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            fun = @(para) <a class="code" href="../../de/da6/_w_o_l_s_8m.html#a13947ac7e36c1a321510c2c370e26450">WOLS</a>(t, para,  h,data_cell ,int_opts);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    end</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    % Optimization settings</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    opt = struct();</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    if(~isempty(Model.optim.gloalg.name))</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        opt.algorithm =  Model.optim.gloalg.name;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        opt.set_population = Model.optim.gloalg.starts;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        opt.local_optimizer.algorithm = Model.optim.alg.name;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        opt.local_optimizer.ftol_rel = 1e-4;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        opt.local_optimizer.xtol_rel = 1e-4;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        opt.maxeval= Model.optim.gloalg.maxeval;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    else</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        opt.algorithm =  Model.optim.alg.name;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        opt.ftol_rel = f_tol;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        opt.xtol_rel = x_tol;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    end</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    opt.min_objective = fun;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    % May need constarints if ODE integration fails due to pathological parameters</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    if ~isempty(Model.indParams.lowerbounds)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        opt.lower_bounds=Model.indParams.lowerbounds;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        opt.upper_bounds=Model.indParams.upperbounds;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    end</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    [x_ols(i, :), fval_ols(i), exflg(i)] = nlopt_optimize(opt, beta_init);</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    if Model.showStatus==true</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        disp([&#39;First estimates for cell: &#39;,num2str(i)]);</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    end</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;end</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;t2 = toc(t1);</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    if Model.showStatus==true</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;sprintf(&#39; First estimates done&#39;)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    end</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;% This pooled estimation is run only if the pool flag is 1. If not</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;% the result from the first estimation above is returned as is to the user.</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;% along with the simulated model.</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;if Model.poolFlg==1</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;%% GLS-POOL</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;% Initialise with <a class="code" href="../../db/d07/_o_l_s_8m.html#adb856b6f2c035e44401151c19a1b16e4">OLS</a> estimate: beta_init.</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;beta_init = x_ols;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160; </div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;% iteration counters</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;itern = 0;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;iternact=0;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;% estimates in the first iteration</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;betai_gls = beta_init;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;theta_gls = theta_init;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;theta_hat=theta_init;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;% Convergence score.</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;score = 10^5; % Initialise the score to a large number</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;diffs = [];   % to store convergence</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;% To store parameters</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;diff_noise = [];</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;diff_betas=zeros(n_cells,Model.indParams.numPars,max_iter_GLS);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;diff_fval = [];</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160; </div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;% Start GLS-POOL estimation</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;t3 = tic;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;while (itern == 0 || ((itern &lt; max_iter_GLS-min_iter_GLS) &amp;&amp; (score &gt;= max_score)))  % Convergence criteria</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160; </div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    % Evaluate the model at previous estimates.</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    for_pool=struct();</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160; </div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;   parfor i=1:n_cells</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        int_opts=struct();</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        if isempty(Model.simulation.options)</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            int_opts.abstol=1e-8;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            int_opts.rtol=1e-6;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            int_opts.k=[];</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        else</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            int_opts.abstol=Model.simulation.abstol;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            int_opts.rtol=Model.simulation.rtol;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;            int_opts.k=Model.simulation.k;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            int_opts.t0=Model.simulation.t0;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        end</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        t = unique(data.Time(data.TrackID == ids(i)));</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        [~, f_t]=<a class="code" href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a>(t,betai_gls(i,:),[],[],int_opts); % Integrating with first order sensitivities</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        for_pool(i).f_t=f_t;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;   end</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    for n_obs=1:length(Model.noiseParams.type)</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    % Maximize noise parameters with</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    if  strcmp(Model.noiseParams.optim,&#39;AR&#39;)</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        fun = @(para) <a class="code" href="../../d2/dee/get___a_r__gm_8m.html#ae4ac1585a9f9586bc9cd3c568c87b6f0">get_AR_gm</a>(for_pool,  para, data, ids,Model.noiseParams.type,n_obs);</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    else</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        fun = @(para) <a class="code" href="../../d4/dc9/get___p_l__gm_8m.html#aa13fb8d33e0707ddf898900de6171cd9">get_PL_gm</a>(for_pool,  para, data, ids,Model.noiseParams.type,n_obs);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    end</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160; </div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    opt_noise = struct();</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    opt_noise.algorithm = Model.optim.alg.name;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    opt_noise.min_objective = fun;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    opt_noise.ftol_rel = f_tol_gls;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    opt_noise.xtol_rel = x_tol_gls;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    %opt_noise.maxeval = 1;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    [theta_hat0, ~,~] = nlopt_optimize(opt_noise, theta_gls{n_obs});</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    theta_hat{n_obs}=theta_hat0;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    end</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    % initalizeing the array to store result of <span class="keyword">new</span> individual</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    % estimates</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    betai_hat = zeros(n_cells, n_kinetic_params);</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160; </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    % Construct weights with theta_hat and maximize parameters</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;   parfor i = 1: n_cells</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        int_opts=<span class="keyword">struct</span>();</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160; </div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="keywordflow">if</span> isempty(Model.simulation.options)</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            int_opts.abstol=1e-8;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;            int_opts.rtol=1e-6;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            int_opts.k=[];</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        else</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            int_opts.abstol=Model.simulation.abstol;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            int_opts.rtol=Model.simulation.rtol;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;            int_opts.k=Model.simulation.k;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            int_opts.t0=Model.simulation.t0;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        end</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        t = unique(data.Time(data.TrackID == ids(i)));</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160; </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160; </div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        % Get the new weights</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        h=<a class="code" href="../../d8/d7b/var_fun_8m.html#ae8689ef39372b131ddb25d7da78d2b87">varFun</a>(theta_hat,for_pool(i).f_t,Model.noiseParams.type);</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160; </div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        % Re-estimate individual parameters with new weights</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        fun = @(para) <a class="code" href="../../de/da6/_w_o_l_s_8m.html#a13947ac7e36c1a321510c2c370e26450">WOLS</a>(t, para,  h, data(data.TrackID == ids(i),:),int_opts);</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        opt = struct();</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        opt.algorithm = Model.optim.alg.name;</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        %opt.maxeval= 1e4;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        opt.min_objective = fun;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160; </div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        % Using low tolerances here can lead to bad estimates.</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        opt.ftol_rel = f_tol_gls;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        opt.xtol_rel = x_tol_gls;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160; </div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        % May need constarints if ODE integration fails due to pathological parameters</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        if ~isempty(Model.indParams.lowerbounds)</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;            opt.lower_bounds=Model.indParams.lowerbounds;</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            opt.upper_bounds=Model.indParams.upperbounds;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        end</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        [betai_hat(i, :), fval(i), exflg(i)] = nlopt_optimize(opt, betai_gls(i, : ));</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160; </div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        if Model.showStatus==1</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            disp([&#39;<a class="code" href="../../de/da6/_w_o_l_s_8m.html#a13947ac7e36c1a321510c2c370e26450">WOLS</a>: Cell: &#39;,num2str(i)]);</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        end</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    end</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160; </div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    % Get the convergence measurement and store, based on relative convergence</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    score1 = max(max(abs((betai_hat - betai_gls)./ betai_gls)));</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    score2 = max(abs(cell2mat(theta_hat)-cell2mat(theta_gls))./cell2mat(theta_gls));</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    score = min(score1, score2);</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    diffs = cat(1, diffs, cat(2, score2, score1));</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160; </div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    diff_noise = cat(1, diff_noise, theta_hat);</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    diff_fval = cat(2, diff_fval, fval);</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160; </div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160; </div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    % Set for iterator</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    iternact = iternact + 1;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    diff_betas(:,:,iternact)=betai_hat;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    itern = max(0, iternact - min_iter_GLS);</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    betai_gls = betai_hat;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    theta_gls = theta_hat;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160; </div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;end</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;else</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    theta_hat=theta_init;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    disp(&#39;Unpooled estimation is not currently implemented, returning <a class="code" href="../../db/d07/_o_l_s_8m.html#adb856b6f2c035e44401151c19a1b16e4">OLS</a>/<a class="code" href="../../de/da6/_w_o_l_s_8m.html#a13947ac7e36c1a321510c2c370e26450">WOLS</a> estimates from the intial run&#39;)</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    warning(&#39;It is recommended to iterate over the GLS atleast once, currently this is implemented only for pooled estimation&#39;)</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    for n_obs=1:n_observables</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    theta_hat{n_obs}=ones(size(theta_hat{n_obs}));</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    end</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160; </div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    betai_hat=x_ols;</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    fval=fval_ols;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    exflg=exflg;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    diff_noise=[];</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    diff_fval=[];</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;    diffs=[];</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;end</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160; </div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;%% Calculate <span class="keyword">final</span> residuals <span class="keyword">using</span> estimated kinetic and noise parameters</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;% Calculate the sigma from the residuals</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;for_pool = <span class="keyword">struct</span>();</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;<span class="keywordflow">for</span> i = 1: n_cells</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    p =  betai_hat(i,:);</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    int_opts=<span class="keyword">struct</span>();</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160; </div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <span class="keywordflow">if</span> isempty(Model.simulation.options)</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        int_opts.abstol=1e-8;</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        int_opts.rtol=1e-6;</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        int_opts.k=[];</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    else</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160; </div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        int_opts.abstol=Model.simulation.abstol;</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        int_opts.rtol=Model.simulation.rtol;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;        int_opts.model=Model.simulation.fn;</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;        int_opts.k=Model.simulation.k;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        int_opts.t0=Model.simulation.t0;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    end</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    t = unique(data.Time(data.TrackID == ids(i)));</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    [~,for_pool(i).f_t]=<a class="code" href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a>(t,p,[],[],int_opts);</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160; </div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    for n_obs=1:size(for_pool(i).f_t,2)</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        [for_pool(i).res(:,n_obs), for_pool(i).h(:,n_obs), for_pool(i).gm(:,n_obs)] = <a class="code" href="../../d0/de2/_w_l_s__gm_8m.html#a664af4d6d1b7d8d8d831606b4ee1ab86">WLS_gm</a>(for_pool(i).f_t,theta_hat, data(data.TrackID == ids(i), {<span class="charliteral">&#39;Y&#39;</span>,<span class="stringliteral">&#39;YID&#39;</span>} ),Model.noiseParams.type,n_obs,0);</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    end</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;end</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160; </div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;% Calculate the estimate of sigma2 and the scaling parameter (eta, in book) (<span class="keywordflow">for</span> AR)</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;sigma = (cell2mat({for_pool.res}<span class="stringliteral">&#39;)./cell2mat({for_pool.h}&#39;</span>)).^2;</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;sigma2 = nansum(sigma) ./ (sum(~isnan(sigma),1) - size(betai_hat, 2) * size(betai_hat, 1));</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;<span class="keywordflow">if</span> any(sigma2&lt;0)</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    sigma2(sigma2&lt;0)=nansum(sigma(sigma2&lt;0)) ./ (sum(~isnan(sigma(sigma2&lt;0)),1));</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;end</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160; </div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;e_ij = abs((cell2mat({for_pool.res}<span class="stringliteral">&#39;)./(sqrt(sigma2).*cell2mat({for_pool.h}&#39;</span>))));</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;E_eij = mean(e_ij);</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;AR_scaling=mat2cell( E_eij .* sqrt(sigma2), 1 , ones(1,n_obs));</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;sigma2_sqrt=mat2cell(sqrt(sigma2), 1 , ones(1,n_obs));</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160; </div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;% Usually we always assume in the end the error is gaussian, and take the</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;theta_hat_sigma=cellfun(@times, theta_hat,sigma2_sqrt,<span class="stringliteral">&#39;uni&#39;</span>,0);</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160; </div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160; </div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;% Make directory to save results, and save all results in a structure and some variables in the MAT file.</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;mkdir(sprintf(<span class="stringliteral">&#39;%s&#39;</span>,out_dir))</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;singlecell_estimates=<span class="keyword">struct</span>();</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160; </div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160; </div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;% Get the uncertainities of the estimate!</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    disp(<span class="stringliteral">&#39;Starting to Calculating the FIM/ Hessian with pooled residuals, if the user function is provided&#39;</span>);</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="keywordflow">for</span> i=1:size(betai_hat,1)</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    singlecell_estimates(i).t=unique(data.Time(data.TrackID==ids(i),:));   % Time</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    singlecell_estimates(i).dat=data(data.TrackID==ids(i),{<span class="stringliteral">&#39;YID&#39;</span>,<span class="charliteral">&#39;Y&#39;</span>});    % data</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    singlecell_estimates(i).params=betai_hat(i,:);            % estimates of parameters</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    px=betai_hat(i,:);</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160; </div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;     <span class="keywordflow">if</span> ~isfile([<span class="charliteral">&#39;.&#39;</span>,filesep,<span class="stringliteral">&#39;UserFns&#39;</span>,filesep,<span class="stringliteral">&#39;getHessianApprox.m&#39;</span>])</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;            [~,obs_y,~,~,Hessian,FIM,measurement_sd,residuals] = <a class="code" href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a>(singlecell_estimates(i).t,px,singlecell_estimates(i).dat,theta_hat_sigma,int_opts,Model.noiseParams.type);</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;     <span class="keywordflow">else</span></div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;            [~,obs_y,~,~,Hessian,FIM,measurement_sd,residuals] = <a class="code" href="../../d5/dec/get_hessian_approx_8m.html#a91eb97cc5c2b99ceb12c24f9a9d86920">getHessianApprox</a>(singlecell_estimates(i).t,px,singlecell_estimates(i).dat,theta_hat_sigma,int_opts,Model.noiseParams.type);</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;     end</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160; </div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    singlecell_estimates(i).obs_y=obs_y;</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;    singlecell_estimates(i).FIM=FIM;                          % FIM</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    singlecell_estimates(i).Hessian=Hessian;                  % Hessian</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    singlecell_estimates(i).int_opts=int_opts;                % Integration options</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    singlecell_estimates(i).exflg=exflg(i);                   % Exit flags of the individual optimization of cells</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    singlecell_estimates(i).fval=fval(i);                     % Objective value <span class="keywordflow">for</span> parameter estimation in the last iteration</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    singlecell_estimates(i).cell_ID=ids(i);                   % Cell IDs</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    singlecell_estimates(i).Track_IDs=unique(data.TrackID(data.TrackID==ids(i),:));                   % TrackIDs</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keywordflow">if</span> any(strcmp(<span class="stringliteral">&#39;PopulationID&#39;</span>,data.Properties.VariableNames))</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    singlecell_estimates(i).PopulationID=unique(data.PopulationID(data.TrackID==ids(i),:));    % Population ID if available</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    else</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    singlecell_estimates(i).PopulationID=1;</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    end</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    singlecell_estimates(i).residuals=residuals;                  % Final resiuals for the cell</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    singlecell_estimates(i).measurement_sd=measurement_sd;        % Final measurement model</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;end</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160; </div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160; </div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;spmd, cpu_end = cputime() - cpu0;, end;</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;spmd, cptime = gplus(cpu_end);, end;</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;cpu_end = cell2mat(cpu_end(: ));</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;cptime = unique(cell2mat(cptime(: )));</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160; </div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;convergene_values=struct();</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;convergene_values.diff_noise= diff_noise; % noise values at every iteration</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;convergene_values.diffs=diffs;            % convergence criteria at every iteration</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160; </div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;%% Save</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;mkdir(out_dir);</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160; </div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;% Save results</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;save([out_dir, fname, &#39;.mat&#39;],...</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;    &#39;convergene_values&#39;, &#39;singlecell_estimates&#39;,&#39;cpu_end&#39;,...</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    &#39;theta_hat_sigma&#39;,&#39;theta_hat&#39;,&#39;cptime&#39;,&#39;Model&#39;,&#39;ids&#39;,&#39;AR_scaling&#39;,...</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    &#39;sigma2_sqrt&#39;)</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;% end parallelization.</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;delete(gcp(&#39;nocreate&#39;))</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aget___a_r__gm_8m_html_ae4ac1585a9f9586bc9cd3c568c87b6f0"><div class="ttname"><a href="../../d2/dee/get___a_r__gm_8m.html#ae4ac1585a9f9586bc9cd3c568c87b6f0">get_AR_gm</a></div><div class="ttdeci">function get_AR_gm(in sim_struct, in noise_params, in data, in indexes, in type, in n_obs)</div><div class="ttdoc">get_AR_gm gets the pooled AR (absolute residuals) likelihood. Implementation is based on &quot;Some Simple...</div></div>
<div class="ttc" id="a_projects_2_llamosi2016_2_user_fns_2call_simulation_8m_html_a675cf3332f7c9140d55c01870b188396"><div class="ttname"><a href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a></div><div class="ttdeci">function callSimulation(in varargin)</div></div>
<div class="ttc" id="a_o_l_s_8m_html_adb856b6f2c035e44401151c19a1b16e4"><div class="ttname"><a href="../../db/d07/_o_l_s_8m.html#adb856b6f2c035e44401151c19a1b16e4">OLS</a></div><div class="ttdeci">function OLS(in t, in kinetic_params, in d, in int_opts)</div><div class="ttdoc">OLS does standard OLS (Ordinary Least Squares, OLS)</div></div>
<div class="ttc" id="a_w_o_l_s_8m_html_a13947ac7e36c1a321510c2c370e26450"><div class="ttname"><a href="../../de/da6/_w_o_l_s_8m.html#a13947ac7e36c1a321510c2c370e26450">WOLS</a></div><div class="ttdeci">function WOLS(in t, in kinetic_params, in measurement_noise, in d, in int_opts)</div><div class="ttdoc">WOLS standard WOLS, weighted LS method.</div></div>
<div class="ttc" id="a_first_stage_8m_html_a7db8a749658a67a5fefefd5909903f73"><div class="ttname"><a href="../../d7/d01/_first_stage_8m.html#a7db8a749658a67a5fefefd5909903f73">FirstStage</a></div><div class="ttdeci">function FirstStage(in model_struct, in data_table, in fname)</div></div>
<div class="ttc" id="aget_hessian_approx_8m_html_a91eb97cc5c2b99ceb12c24f9a9d86920"><div class="ttname"><a href="../../d5/dec/get_hessian_approx_8m.html#a91eb97cc5c2b99ceb12c24f9a9d86920">getHessianApprox</a></div><div class="ttdeci">function getHessianApprox(in t, in para, in ydata, in noise_params, in int_opts, in noise_params_type)</div></div>
<div class="ttc" id="avar_fun_8m_html_ae8689ef39372b131ddb25d7da78d2b87"><div class="ttname"><a href="../../d8/d7b/var_fun_8m.html#ae8689ef39372b131ddb25d7da78d2b87">varFun</a></div><div class="ttdeci">function varFun(in noise_params, in f_t, in var_type, in varargin)</div><div class="ttdoc">varFun is a function that returns the variance model</div></div>
<div class="ttc" id="aget___p_l__gm_8m_html_aa13fb8d33e0707ddf898900de6171cd9"><div class="ttname"><a href="../../d4/dc9/get___p_l__gm_8m.html#aa13fb8d33e0707ddf898900de6171cd9">get_PL_gm</a></div><div class="ttdeci">function get_PL_gm(in sim_struct, in noise_params, in data, in indexes, in type, in n_obs)</div><div class="ttdoc">get_PL_gm gets the pooled PL. Implementation is based on &quot;Some Simple Methods for Estimating Intraind...</div></div>
<div class="ttc" id="a_w_l_s__gm_8m_html_a664af4d6d1b7d8d8d831606b4ee1ab86"><div class="ttname"><a href="../../d0/de2/_w_l_s__gm_8m.html#a664af4d6d1b7d8d8d831606b4ee1ab86">WLS_gm</a></div><div class="ttdeci">function WLS_gm(in f_t, in noise_params, in d, in type, in n_obs, in varargin)</div><div class="ttdoc">WLS_gm is used by get_AR_gm and get_PL_gm.m Generates the things needed to compute the AR/ PL objecti...</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
